precision highp float;

uniform sampler2D vTextureX;//Y, RGBA
uniform sampler2D vTextureY;//U, UV
uniform sampler2D vTextureZ;//V
uniform int vFormat;
varying vec2 aCoordinate;

vec4 cFormat(vec3 yuv) {
    float y = 1.164 * (yuv.x - 0.0625);
    float u = yuv.y - .5;
    float v = yuv.z - .5;
    float r = clamp(y + 1.646 * v, 0., 1.);
    float g = clamp(y - 0.391 * u - 0.853 * v, 0., 1.);
    float b = clamp(y + 2.018 * u, 0., 1.);
    return vec4(r, g, b, 1.);
}

void main(){
    vec3 yuv = vec3(0.);
    if(vFormat == 2) {// I420
        yuv.x = texture2D(vTextureX, aCoordinate).r;
        yuv.y = texture2D(vTextureY, aCoordinate).r;
        yuv.z = texture2D(vTextureZ, aCoordinate).r;
        gl_FragColor = cFormat(yuv);
    } else if(vFormat == 1) { // NV12
        yuv.x = texture2D(vTextureX, aCoordinate).r /*- 16./255.*/;
        yuv.y = texture2D(vTextureY, aCoordinate).r;
        yuv.z = texture2D(vTextureY, aCoordinate).a;
        gl_FragColor = cFormat(yuv);
    } else { // rgba
        gl_FragColor = texture2D(vTextureX,aCoordinate);
    }
}
