precision mediump float;
uniform sampler2D fromTexture;
uniform sampler2D toTexture;
uniform float progress;
varying vec2 aCoordinate;

const vec2 direction = vec2(-1.0, 1.0);
const float smoothness = 0.5;
const vec2 center = vec2(0.5, 0.5);


void main(){
    vec2 uv = aCoordinate;

    vec2 v = normalize(direction);
    v /= abs(v.x) + abs(v.y);
    float d = v.x * center.x + v.y * center.y;
    float m = 1.0 - smoothstep(-smoothness, 0.0, v.x * uv.x + v.y * uv.y - (d - 0.5 + progress * (1.0 + smoothness)));

    vec4 from = texture2D(fromTexture, (uv - 0.5) * (1.0 - m) + 0.5);
    vec4 to = texture2D(toTexture, (uv - 0.5) * m + 0.5);
    gl_FragColor = mix(from, to, m);
}